package core

import (
	"eta_gn/eta_bridge/global"
	"eta_gn/eta_bridge/init_serve"
	"fmt"
)

func RunServe() {
	// 初始化路由
	r := init_serve.InitRouter()

	// 如果配置了redis，那么链接redis
	if global.CONFIG.Serve.UseRedis {
		//初始化redis
		init_serve.Redis()
	}

	// 初始化mysql数据库
	//init_serve.Mysql()
	// 初始化 达梦数据库
	init_serve.InitDm()

	// 启动任务
	init_serve.InitTask()

	fmt.Println("port:", global.CONFIG.Serve.Port)
	err := r.Run(fmt.Sprint("0.0.0.0:", global.CONFIG.Serve.Port)) // 监听并在 0.0.0.0:8080 上启动服务
	if err != nil {
		panic(fmt.Errorf("服务启动失败，Err:%s", err))
	} else {
		fmt.Println("Run:", fmt.Sprint("0.0.0.0:", global.CONFIG.Serve.Port))
	}
}
