package init_serve

import (
	"eta_gn/eta_bridge/global"
	"eta_gn/eta_bridge/services/index_data"
	"github.com/robfig/cron/v3"
)

func InitTask() {
	// 如果配置文件中设置了停止任务，则不执行定时任务
	// 此功能用于多服务器部署时，定时任务只需一台服务器执行，其他服务器不执行；所以只需要一台服务器设置为false，其他服务器设置为true
	if global.CONFIG.Serve.IsStopTask {
		return
	}

	// 修复数据
	//if global.CONFIG.Gn.DataHost != `` {
	//	fmt.Println("开始修复数据了")
	//	index_data.FixData()
	//}

	// 开始定时任务
	c := cron.New(cron.WithSeconds())

	// 定时清除指标更新日志
	if global.CONFIG.Mysql.Binlog.IsListen {
		_, err := c.AddFunc("0 0 0 * * *", index_data.DeleteBeforeTenDayLog)
		if err != nil {
			global.LOG.Error("DeleteBeforeTenDayLog err" + err.Error())
		}
	}

	c.Start()
}
