package crm

import (
	"eta_gn/eta_bridge/global"
	"time"
)

type OpenApiUser struct {
	Appid      string    `gorm:"primaryKey;column:appid;type:varchar(32);not null;default:''" json:"appid"`      // 开放平台appid
	Secret     string    `gorm:"column:secret;type:varchar(64);default:''" json:"secret"`                        // 开放平台秘钥
	Ip         string    `gorm:"column:ip;type:text" json:"ip"`                                                  // 限制请求来源ip，多个ip用英文,隔开
	Remark     string    `gorm:"column:remark;type:varchar(255);default:''" json:"remark"`                       // 备注，记录来源等信息
	CreateTime time.Time `gorm:"column:create_time;type:timestamp;default:CURRENT_TIMESTAMP" json:"create_time"` // 创建时间
	ModifyTime time.Time `gorm:"column:modify_time;type:datetime" json:"modify_time"`                            // 最近一次更新时间
}

func (m *OpenApiUser) TableName() string {
	return "open_api_user"
}

// GetItemByAppid AppID获取信息
func (m *OpenApiUser) GetItemByAppid(appid string) (item *OpenApiUser, err error) {
	err = global.MYSQL["hz_crm"].Model(m).Where("appid = ?", appid).First(&item).Error
	return
}
