package eta

import (
	"eta_gn/eta_bridge/global"
	"time"
)

const (
	ConfEnAuthRoleKey = "en_auth_role" // 英文权限角色配置Key
)

// CrmConfig CRM配置表
type CrmConfig struct {
	ConfigId    int       `gorm:"primaryKey;column:config_id;type:int(11);not null" json:"config_id"`
	ConfigCode  string    `gorm:"column:config_code;type:varchar(50);default:''" json:"config_code"` // 配置编码
	ConfigValue string    `gorm:"column:config_value;type:text" json:"config_value"`                 // 配置值
	Remark      string    `gorm:"column:remark;type:varchar(255);default:''" json:"remark"`          // 备注信息
	CreateTime  time.Time `gorm:"column:create_time;type:datetime" json:"create_time"`               // 创建时间
}

func (m *CrmConfig) TableName() string {
	return "crm_config"
}

// GetCrmConfByCode code获取配置
func GetCrmConfByCode(code string) (item *CrmConfig, err error) {
	err = global.MYSQL["hz_eta"].Where("config_code = ?", code).First(&item).Error
	return
}

// ConfEnAuthRole 配置-英文权限角色
type ConfEnAuthRole struct {
	RoleCode string `description:"角色编码"`
	RoleName string `description:"角色名称"`
	SyncCrm  bool   `description:"是否同步CRM"`
}
