package gn

import "eta_gn/eta_bridge/global"

// OaDept OA部门
type OaDept struct {
	DepartmentId       string `json:"dept_id" description:"部门ID"`
	DepartmentName     string `json:"deptname" description:"部门名称"`
	ParentDepartmentId string `json:"pdeptid" description:"上级部门名称"`
}

// OaUser OA用户
type OaUser struct {
	AddrName               string `gorm:"column:addr_name" json:"addr_name" description:"姓名"`
	AddrUserId             string `gorm:"column:addr_Userid" json:"addr_Userid" description:"用户ID"`
	AddrOfficeTel          string `gorm:"column:addr_OfficeTel" json:"addr_OfficeTel" description:"办公电话"`
	AddrMobilePhone        string `gorm:"column:addr_MobilePhone" json:"addr_MobilePhone" description:"手机号"`
	AddrJobTitle           string `gorm:"column:addr_JobTitle" json:"addr_JobTitle" description:"职位"`
	AddrEmployeeId         string `gorm:"column:addr_EMPLOYEEID" json:"addr_EMPLOYEEID" description:""`
	AddrDepartmentFullName string `gorm:"column:addr_DepFullname" json:"addr_DepFullname" description:"部门全称, 格式:直属部门/上级部门/顶级部门, 层级不定"`
	OEmployeeNo            string `gorm:"column:o_EMPLOYEENO" json:"o_EMPLOYEENO" description:"OA工号"`
}

// GetGnOaDepartment 获取OA部门
func GetGnOaDepartment() (items []*OaDept, err error) {
	sql := `SELECT * FROM oa_dept `
	err = global.MYSQL["oa_user"].Raw(sql).Find(&items).Error
	return
}

// GetGnOaUser 获取OA用户
func GetGnOaUser() (items []*OaUser, err error) {
	sql := `SELECT * FROM oa_user `
	err = global.MYSQL["oa_user"].Raw(sql).Find(&items).Error
	return
}

// UserEntity枚举值
const (
	UserStatusActive  = "Active"
	UserStatusDisable = "Disabled"
	UserIsByWorkFull  = "全职"
	UserIsByWorkPart  = "兼职"
)

// UserEntity 4A用户字段
//type UserEntity11 struct {
//	UserId         string                 `json:"userId" description:"登录账号标识[必填], string:256"`
//	Password       string                 `json:"password" description:"密码（预留，4A平台不提供）, string:256"`
//	OrgCode        string                 `json:"orgCode" description:"对应MDM组织机构-单位的编号（预留，4A平台不提供）, string:8"`
//	OrgName        string                 `json:"orgName" description:"对应员工直接所属的MDM组织机构-单位名称（预留，4A平台不提供）, string:40"`
//	DepartmentNum  string                 `json:"departmentNum" description:"对应MDM组织机构-部门的编号（预留，4A平台不提供）, string:8"`
//	DepartmentName string                 `json:"departmentName" description:"对应员工直接所属的MDM组织机构-部门名称（预留，4A平台不提供）, string:40"`
//	FirstName      string                 `json:"firstName" description:"身份证中的名[必填], string:150"`
//	LastName       string                 `json:"lastName" description:"身份证中的姓[必填], string:150"`
//	Sex            string                 `json:"sex" description:"员工性别（预留，4A平台不提供）, string:10"`
//	UserType       string                 `json:"userType" description:"用户类型, 枚举值（预留，4A平台不提供）, string:256"`
//	Mail           string                 `json:"mail" description:"员工邮箱（预留，4A平台不提供）, string: 256"`
//	DisplayIndex   int                    `json:"displayIndex" description:"排序（预留，4A平台不提供）, int: 256"`
//	Mobile         string                 `json:"mobile" description:"员工手机号, 可能存在多值（预留，4A平台不提供）, string:50"`
//	Telephone      string                 `json:"telephone" description:"员工办公室电话, 可能存在多值（预留，4A平台不提供）, string:50"`
//	PID            string                 `json:"PID" description:"身份证号（预留，4A平台不提供）, string: 50"`
//	PassportId     string                 `json:"passportID" description:"护照号（预留，4A平台不提供）, string:50"`
//	UserStatus     string                 `json:"userStatus" description:"账号状态[必填], 枚举值: Active-激活; Disabled-禁用, string:256"`
//	EmpNumber      string                 `json:"empNumber" description:"员工在ERP系统中的唯一编号, 默认与账号标识一致（预留，4A平台不提供）, string:256"`
//	Title          string                 `json:"title" description:"员工主职位编号（预留，4A平台不提供）, string:40"`
//	TitleName      string                 `json:"titleName" description:"员工主职位名称（预留，4A平台不提供）, string:256"`
//	IsByWork       string                 `json:"isBywork" description:"是否兼职（预留，4A平台不提供）, 枚举值: 全职-MDM推送的全职人员信息, string:10"`
//	Extensions     map[string]interface{} `json:"extensions" description:"扩展字段, key-value"`
//}

// UserEntity 4A用户字段
type UserEntity struct {
	UserId         *string `json:"userId" description:"登录账号标识[必填], string:256"`
	Password       *string `json:"password" description:"密码（预留，4A平台不提供）, string:256"`
	OrgCode        *string `json:"orgCode" description:"对应MDM组织机构-单位的编号（预留，4A平台不提供）, string:8"`
	OrgName        *string `json:"orgName" description:"对应员工直接所属的MDM组织机构-单位名称（预留，4A平台不提供）, string:40"`
	DepartmentNum  *string `json:"departmentNum" description:"对应MDM组织机构-部门的编号（预留，4A平台不提供）, string:8"`
	DepartmentName *string `json:"departmentName" description:"对应员工直接所属的MDM组织机构-部门名称（预留，4A平台不提供）, string:40"`
	FirstName      *string `json:"firstName" description:"身份证中的名[必填], string:150"`
	LastName       *string `json:"lastName" description:"身份证中的姓[必填], string:150"`
	Sex            *string `json:"sex" description:"员工性别（预留，4A平台不提供）, string:10"`
	UserType       *string `json:"userType" description:"用户类型, 枚举值（预留，4A平台不提供）, string:256"`
	Mail           *string `json:"mail" description:"员工邮箱（预留，4A平台不提供）, string: 256"`
	DisplayIndex   *int    `json:"displayIndex" description:"排序（预留，4A平台不提供）, int: 256"`
	Mobile         *string `json:"mobile" description:"员工手机号, 可能存在多值（预留，4A平台不提供）, string:50"`
	Telephone      *string `json:"telephone" description:"员工办公室电话, 可能存在多值（预留，4A平台不提供）, string:50"`
	PID            *string `json:"PID" description:"身份证号（预留，4A平台不提供）, string: 50"`
	PassportId     *string `json:"passportID" description:"护照号（预留，4A平台不提供）, string:50"`
	UserStatus     *string `json:"userStatus" description:"账号状态[必填], 枚举值: Active-激活; Disabled-禁用, string:256"`
	EmpNumber      *string `json:"empNumber" description:"员工在ERP系统中的唯一编号, 默认与账号标识一致（预留，4A平台不提供）, string:256"`
	Title          *string `json:"title" description:"员工主职位编号（预留，4A平台不提供）, string:40"`
	TitleName      *string `json:"titleName" description:"员工主职位名称（预留，4A平台不提供）, string:256"`
	IsByWork       *string `json:"isBywork" description:"是否兼职（预留，4A平台不提供）, 枚举值: 全职-MDM推送的全职人员信息, string:10"`
	Extensions     *string `json:"extensions" description:"扩展字段, key-value"`
}
