package gn

import (
	gnModel "eta_gn/eta_bridge/models/gn"
	"time"
)

// AddAccountReq 创建账号请求
type AddAccountReq struct {
	gnModel.UserEntity `description:"账号信息"`
	RequestId          string    `json:"requestID" description:"请求唯一标识"`
	TimeStamp          time.Time `json:"timeStamp" description:"时间戳"`
}

// ModifyAccountReq 编辑账号请求
type ModifyAccountReq struct {
	gnModel.UserEntity `description:"账号信息"`
	RequestId          string    `json:"requestID" description:"请求唯一标识"`
	TimeStamp          time.Time `json:"timeStamp" description:"时间戳"`
}

// DeleteAccountReq 删除账号请求
type DeleteAccountReq struct {
	UserId    string    `json:"userId" description:"用户名"`
	RequestId string    `json:"requestID" description:"请求唯一标识"`
	TimeStamp time.Time `json:"timeStamp" description:"时间戳"`
}

// SuspendAccountReq 禁用账号请求
type SuspendAccountReq struct {
	UserId    string    `json:"userId" description:"用户名"`
	RequestId string    `json:"requestID" description:"请求唯一标识"`
	TimeStamp time.Time `json:"timeStamp" description:"时间戳"`
}

// RestoreAccountReq 启用账号请求
type RestoreAccountReq struct {
	UserId    string    `json:"userId" description:"用户名"`
	RequestId string    `json:"requestID" description:"请求唯一标识"`
	TimeStamp time.Time `json:"timeStamp" description:"时间戳"`
}

// ChangePasswordReq 修改密码请求
type ChangePasswordReq struct {
	UserId      string    `json:"userId" description:"用户名"`
	NewPassword string    `json:"newPassword" description:"新密码"`
	RequestId   string    `json:"requestID" description:"请求唯一标识"`
	TimeStamp   time.Time `json:"timeStamp" description:"时间戳"`
}
