package alarm_msg

import (
	"encoding/json"
	"eta_gn/eta_bridge/global"
	"eta_gn/eta_bridge/utils"
)

var (
	AlarmMsgUrl = "http://127.0.0.1:8606/api/alarm/send"
)

// SendAlarmMsg
// projectName-项目名称
// runMode-运行模式
// msgBody-消息内容
// level:消息基本,1:提示消息,2:警告消息,3:严重错误信息,默认为1 提示消息
func SendAlarmMsg(msgBody string, level int) {
	params := make(map[string]interface{})
	params["ProjectName"] = utils.APPNAME
	params["RunMode"] = global.CONFIG.Serve.RunMode
	params["MsgBody"] = msgBody
	params["Level"] = level
	param, err := json.Marshal(params)
	if err != nil {
		global.LOG.Critical("SendAlarmMsg json.Marshal Err:" + err.Error())
		return
	}
	global.FILE_LOG.Info(string(param))
	//_, _ = http.Post(AlarmMsgUrl, string(param))
}
