package utils

// 常量定义
const (
	FormatTime            = "15:04:05"                //时间格式
	FormatDate            = "2006-01-02"              //日期格式
	FormatDateCN          = "2006年01月02日"             //日期格式（中文）
	FormatDateUnSpace     = "20060102"                //日期格式
	FormatDateTime        = "2006-01-02 15:04:05"     //完整时间格式
	HlbFormatDateTime     = "2006-01-02_15:04:05.999" //完整时间格式
	FormatDateTimeUnSpace = "20060102150405"          //完整时间格式
	FormatDateDefault     = "2006-01-02T15:04:05+08:00"
	PageSize15            = 15 //列表页每页数据量
	PageSize5             = 5
	PageSize10            = 10
	PageSize20            = 20
	PageSize30            = 30
)

// 手机号，电子邮箱正则
const (
	RegularMobile = "^((13[0-9])|(14[5|7])|(15([0-3]|[5-9]))|(18[0-9])|(17[0-9])|(16[0-9])|(19[0-9]))\\d{8}$" //手机号码
	RegularEmail  = `\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*`                                             //匹配电子邮箱
)

const (
	APPNAME = "ETA桥接服务"
)

const (
	CACHE_CRM_AUTH_CODE_PREFIX     = "hz_crm_eta:crm_auth_code_" // 免密登录Code-CRM
	CACHE_ETA_AUTH_CODE_PREFIX     = "hz_crm_eta:eta_auth_code_" // 免密登录Code-ETA
	CACHE_EDB_GN_DATA_SERVER_TOKEN = "edb:gn_data_server_token"  // 国能数据节点调用凭证
)

// 管理员，ficc管理员，ficc销售，权益管理员，权益销售。
// 角色类型/类型编码
const (
	ROLE_NAME_FICC_DIRECTOR = "ficc销售经理" // 实际角色类型为ficc销售主管

	ROLE_TYPE_CODE_ADMIN           = "admin"           //管理员
	ROLE_TYPE_CODE_FICC_ADMIN      = "ficc_admin"      //ficc管理员
	ROLE_TYPE_CODE_FICC_SELLER     = "ficc_seller"     //ficc销售
	ROLE_TYPE_CODE_RAI_ADMIN       = "rai_admin"       //权益管理员
	ROLE_TYPE_CODE_RAI_SELLER      = "rai_seller"      //权益销售
	ROLE_TYPE_CODE_FICC_GROUP      = "ficc_group"      //ficc销售主管
	ROLE_TYPE_CODE_RAI_GROUP       = "rai_group"       //ficc组长
	ROLE_TYPE_CODE_FICC_DEPARTMENT = "ficc_department" //ficc部门经理
	ROLE_TYPE_CODE_RAI_DEPARTMENT  = "rai_department"  //权益部门经理
	ROLE_TYPE_CODE_FICC_TEAM       = "ficc_team"       //ficc销售组长
)

const (
	COMPANY_PRODUCT_FICC_ID   = 1
	COMPANY_PRODUCT_FICC_NAME = "ficc"
	COMPANY_PRODUCT_RAI_ID    = 2
	COMPANY_PRODUCT_RAI_NAME  = "权益"
)

// 系统来源
const (
	SOURCE_CRM_FLAG = 1
	SOURCE_ETA_FLAG = 2
)

const CrmEtaAuthorization = "NIi1RbEmH0C2rksXtPGDPBBgRgTZY87Q"

const CACHE_MYSQL_MASTER_FILENAME = "eta:mysql:binlog:filename"
const CACHE_MYSQL_MASTER_POSITION = "eta:mysql:binlog:position"

// MultiAddNum 批量插入的数据量
const MultiAddNum = 500

// 4A接口错误编码
//const (
//	Gn4AErrCodeSuccess = "0"            // 操作成功
//	Gn4AErrCode01      = "LoginErr-001" // 您没有权限登录该系统
//	Gn4AErrCode02      = "LoginErr-002" // 系统内部无此用户
//	Gn4AErrCode03      = "LoginErr-003" // 用户已被禁用
//	Gn4AErrCode04      = "LoginErr-004" // 无法获取登录用户
//	Gn4AErrCode05      = "LoginErr-005" // 用户来源非法
//	Gn4AErrCode06      = "LoginErr-006" // 提交数据异常
//	Gn4AErrCode07      = "LoginErr-007" // 认证服务无法访问
//	Gn4AErrCode08      = "LoginErr-008" // 自定义错误文本
//)
